#ifndef __CUSTOM_MEM_MNGR_H___
#define __CUSTOM_MEM_MNGR_H___

#include "stdafx.h"
#include "stuffs.h"

#define MEM_MNGR_SAFE_MODE

#define mm_malloc(mngr, type, count) ((type*)(mm_malloc_func((mngr), sizeof(type)*(count))))
#define mm_calloc(mngr, type, count) ((type*)(mm_calloc_func((mngr), (count), sizeof(type))))
#define mm_free(ptr, mngr)

#define MM_BUFFERS_COUNT (128)
typedef struct mm_malloc_manager_struct mm_malloc_t;
struct mm_malloc_manager_struct{
    char *buffers[MM_BUFFERS_COUNT];
    int buff_count;
    int free_ptr;
    int part_size;
};

typedef struct mm_mem_mngr_struct mm_context_t;
struct mm_mem_mngr_struct{
    void    *storage_ptr;
    void    **free_pointers_storage;
    void    **free_pointer_ptr;
    void    **end_point;

    int     elements_number;
    size_t  element_size;
    int     max_elements_used;
    int     now_used_elements;
    char    *name;
};

mm_context_t* mm_init_mem_mngr(int elements_num, size_t element_size, char* name);
void mm_free_mem_mngr(mm_context_t *mem_mngr);
void *mm_get_mem(mm_context_t *mem_mngr);
void mm_free_mem(mm_context_t *mem_mngr, void *mem);
int mm_get_free_units_num(mm_context_t *mem_mngr);
void mm_reset_mem_mngr(mm_context_t *mem_mngr);
int mm_get_used_units_num(mm_context_t *mem_mngr);
#endif //__CUSTOM_MEM_MNGR_H___
