// flood-it.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
#include "time.h"
#include "malloc.h"
#include "string.h"

#define THRESHOLD           (6)
#define COLORS_NUM          (500)
#define MEM_POOL_SIZE       (350*350+4)
#define USED_FOR_MAIN_GROUP (1<<0)
#define USED_FOR_NEIGHBOR   (1<<1)


struct node{
    bool ready;

    int color;
	int gr_id;
    unsigned int good_for_start_elememt;

	node* e;
	node* w;
	node* n;
	node* s;

    node* prvs;
    node* next;
};
typedef struct node element_t;

struct neighbor_node {
	int id;
	neighbor_node *next;
};
typedef struct neighbor_node neighbor_t;

struct clr_group_node {
	element_t *element;
	int group_num; // number of elements
	int ngb_num; // number of neighbors
    int used; // add to some neighbor group
    unsigned int good_for_start_elememt;
    int common_clr_with_base;
	neighbor_t neighbors;
	clr_group_node *next;
};
typedef struct clr_group_node group_t;

int group_pool_idx = 0;
group_t group_pool[MEM_POOL_SIZE];
#define node_alloc() (&(group_pool[group_pool_idx++]))

int ngb_pool_idx = 0;
neighbor_t ngb_pool[MEM_POOL_SIZE * 20];
#define ngb_alloc() (&(ngb_pool[ngb_pool_idx++]))

element_t *elements_mem;
element_t *start_list;
element_t *ready_list;
group_t *group_list;
int N;
int C;
int group_id = 0;
int trys = 0;
int group_num;
int ngb_num;
int my_gr_id;
unsigned int good_for_start_elememt;
unsigned int test_group;
int clr_nbr_pool[501];
int clr_stat[501];
int start_time;
int result_id;
int result[2][350*350 + 4];
int trys_ids[100];
int ngb_for_update[MEM_POOL_SIZE];


void move_to_ready(element_t *move)
{
    // remove
    if (move->next) {
        move->next->prvs = move->prvs;
        move->prvs->next = move->next;
    } else {
        move->prvs->next = NULL;
    }

    //add
    move->prvs = ready_list;
    move->next = ready_list->next;

    move->prvs->next = move;
    if(move->next) {
        move->next->prvs = move;
    }

    move->ready = true;
}

inline void add_group(element_t *p, int clr)
{
	if ((p->e) && (false == p->e->ready) && (clr == p->e->color))
    {
		group_num++;
		p->e->gr_id = group_id;
        good_for_start_elememt |= p->e->good_for_start_elememt;
        move_to_ready(p->e);
        add_group(p->e, clr);
    }
    if ((p->w) && (false == p->w->ready) && (clr == p->w->color))
    {
		group_num++;
		p->w->gr_id = group_id;
        good_for_start_elememt |= p->w->good_for_start_elememt;
        move_to_ready(p->w);
        add_group(p->w, clr);
    }
    if ((p->n) && (false == p->n->ready) && (clr == p->n->color))
    {
		group_num++;
		p->n->gr_id = group_id;
        good_for_start_elememt |= p->n->good_for_start_elememt;
        move_to_ready(p->n);
        add_group(p->n, clr);
    }
    if ((p->s) && (false == p->s->ready) && (clr == p->s->color))
    {
		group_num++;
		p->s->gr_id = group_id;
        good_for_start_elememt |= p->s->good_for_start_elememt;
        move_to_ready(p->s);
        add_group(p->s, clr);
    }
}

void add_neighbor(group_t *pGroup, int id)
{
    neighbor_t *nbr = pGroup->neighbors.next;
	neighbor_t *ptr;

	while(nbr)
	{
		if (nbr->id == id)
			return;
		nbr = nbr->next;
	}

    nbr = &pGroup->neighbors;
    while(nbr->next)
    {
        if(id < nbr->next->id)
            break;
        nbr = nbr->next;
    }

    ptr = ngb_alloc();
    ptr->id = id;
    ptr->next = nbr->next;
    nbr->next = ptr;
    ngb_num++;
}

void init(element_t *board, int N)
{
    element_t *curr;
	group_t *pGroup;
    int x, y, idx, id, g_x, g_y;

    group_pool_idx = 0;
    ngb_pool_idx = 0;
    group_id = 0;
    trys = 0;
    test_group = 1;

    memset(clr_nbr_pool, 0, sizeof(clr_nbr_pool));
    memset(trys_ids, 0, sizeof(trys_ids));
    memset(clr_stat, 0, sizeof(clr_stat));

	group_list = node_alloc();

    ready_list = stf_calloc(element_t, 1);    
    start_list = stf_calloc(element_t, 1);
    start_list->next = board;

	board[0].prvs = start_list;
	board[0].next = &board[1];
	for(x = 1; x < (N * N - 1); x++) {
		board[x].next = &board[x+1];
		board[x].prvs = &board[x-1];
	}
	board[N * N - 1].prvs = &board[N * N - 2];
    board[N * N - 1].next = NULL;

	curr = board;

    for(y = 0; y < N; y++) {
        for(x = 0; x < N; x++)
        {
            idx = y * N + x - 1;
            if(idx > (N * y - 1))
                curr->e = &board[idx];

            idx = y * N + x + 1;
            if(idx < (N * (y + 1)))
                curr->w = &board[idx];

            idx = (y - 1) * N + x;
            if(idx > -1)
                curr->n = &board[idx];

            idx = (y + 1) * N + x;
            if(idx < (N * N))
                curr->s = &board[idx];

            g_x = (N / 2) - x;
            g_y = (N / 2) - y;

            if (g_x < 0) {
                g_x = -g_x;
            }
            if (g_y < 0) {
                g_y = -g_y;
            }

            curr->good_for_start_elememt = 0x80000000;
            if(g_x > g_y) {
                if( (g_x / THRESHOLD) < 31 ) {
                    curr->good_for_start_elememt = 1 << (g_x / THRESHOLD);
                }
            } else {
                if( (g_y / THRESHOLD) < 31 ) {
                    curr->good_for_start_elememt = 1 << (g_y / THRESHOLD);
                }
            }

            curr = curr->next;
        }
    }

	// crate groups
	pGroup = group_list;
	while(start_list->next)
	{
		group_num = 1;
		group_id++;
		curr = start_list->next;
		curr->gr_id = group_id;

        good_for_start_elememt = curr->good_for_start_elememt;
		move_to_ready(curr);
		add_group(curr, curr->color);

		pGroup->next = node_alloc();
		pGroup = pGroup->next;
		pGroup->element = ready_list->next;
		pGroup->group_num = group_num;
        pGroup->used = 0;
        pGroup->neighbors.next = NULL;
        pGroup->good_for_start_elememt = good_for_start_elememt;

		ready_list->next = NULL;

        clr_stat[pGroup->element->color] += group_num;
	}

	// get neighbor groups
	pGroup = group_list->next;
	while(pGroup)
	{
		curr = pGroup->element;
		id = pGroup->element->gr_id;
        ngb_num = 0;
		while(curr)
		{
			if((curr->e) && (id != curr->e->gr_id))
				add_neighbor(pGroup, curr->e->gr_id);
			if((curr->w) && (id != curr->w->gr_id))
				add_neighbor(pGroup, curr->w->gr_id);
			if((curr->n) && (id != curr->n->gr_id))
				add_neighbor(pGroup, curr->n->gr_id);
			if((curr->s) && (id != curr->s->gr_id))
				add_neighbor(pGroup, curr->s->gr_id);
			curr = curr->next;
		}
        pGroup->ngb_num = ngb_num;
		pGroup = pGroup->next;
	}
}

void init_sec(element_t *board, int N)
{
    element_t *curr;
	group_t *pGroup;
    int x, id;

    group_pool_idx = 0;
    ngb_pool_idx = 0;
    group_id = 0;
    trys = 0;

    memset(clr_nbr_pool, 0, sizeof(clr_nbr_pool));
    memset(clr_stat,     0, sizeof(clr_stat));

	group_list = node_alloc();

    ready_list = stf_calloc(element_t, 1);    
    start_list = stf_calloc(element_t, 1);
    start_list->next = board;

	board[0].prvs = start_list;
	board[0].next = &board[1];
    board[0].ready = 0;
	for(x = 1; x < (N * N - 1); x++) {
        board[x].ready = 0;
		board[x].next = &board[x+1];
		board[x].prvs = &board[x-1];
	}
	board[N * N - 1].prvs = &board[N * N - 2];
    board[N * N - 1].next = NULL; 
    board[N * N - 1].ready = 0;

	// crate groups
	pGroup = group_list;
	while(start_list->next)
	{
		group_num = 1;
		group_id++;
		curr = start_list->next;
		curr->gr_id = group_id;

        good_for_start_elememt = curr->good_for_start_elememt;
		move_to_ready(curr);
		add_group(curr, curr->color);

		pGroup->next = node_alloc();
		pGroup = pGroup->next;
		pGroup->element = ready_list->next;
		pGroup->group_num = group_num;
        pGroup->used = 0;
        pGroup->neighbors.next = NULL;
        pGroup->good_for_start_elememt = good_for_start_elememt;
        
		ready_list->next = NULL;

        clr_stat[pGroup->element->color] += group_num;
	}

	// get neighbor groups
	pGroup = group_list->next;
	while(pGroup)
	{
		curr = pGroup->element;
		id = pGroup->element->gr_id;
        ngb_num = 0;
		while(curr)
		{
			if((curr->e) && (id != curr->e->gr_id))
				add_neighbor(pGroup, curr->e->gr_id);
			if((curr->w) && (id != curr->w->gr_id))
				add_neighbor(pGroup, curr->w->gr_id);
			if((curr->n) && (id != curr->n->gr_id))
				add_neighbor(pGroup, curr->n->gr_id);
			if((curr->s) && (id != curr->s->gr_id))
				add_neighbor(pGroup, curr->s->gr_id);
			curr = curr->next;
		}
        pGroup->ngb_num = ngb_num;
		pGroup = pGroup->next;
	}
}

inline void update_my_neighbors(int gr_id)
{
    neighbor_t *t;
    
    group_pool[gr_id].ngb_num = 0;
    group_pool[gr_id].common_clr_with_base = 0;
    t = group_pool[gr_id].neighbors.next;
    while(t)
    {
        if(0 == group_pool[t->id].used)
        {
            if(clr_nbr_pool[group_pool[t->id].element->color]) {
                group_pool[gr_id].common_clr_with_base++;
            }
            group_pool[gr_id].ngb_num++;
        }

        t = t->next;
    }
}

// obedinqva na dva syseda s ednakyv cvqt sysedite
void brings_together(int my_ngb_id, int new_ngb_id)
{
    neighbor_t *my_ngb;
    neighbor_t *new_ngb;
    neighbor_t *t;

    my_ngb  = &(group_list[my_ngb_id].neighbors);
    new_ngb = group_list[new_ngb_id].neighbors.next;
    group_list[new_ngb_id].used |= USED_FOR_NEIGHBOR;
    group_list[my_ngb_id].group_num += group_list[new_ngb_id].group_num;

    while(new_ngb)
    {
        if(new_ngb->id > my_ngb->next->id) {
            my_ngb = my_ngb->next;
        } else if((new_ngb->id == my_ngb->next->id) || (0 != (group_list[new_ngb->id].used & USED_FOR_MAIN_GROUP))) {
            new_ngb = new_ngb->next;
        } else { // new_ngb->id < my_ngb->id
            t = new_ngb;
            new_ngb = new_ngb->next;
            t->next = my_ngb->next;
            my_ngb->next = t;
            group_list[my_ngb_id].ngb_num++;
            my_ngb = my_ngb->next;
        }

        if(NULL == my_ngb->next) {
            my_ngb->next = new_ngb;
            break;
        }
    }
}

// tyrsi sysedi s ednakvi cvetove za da gi obedini, a novite gi dobavq
inline void apply_new_color(group_t *pGroup, int new_ngb_id)
{
    neighbor_t *my_ngb;
    neighbor_t *new_ngb;
    neighbor_t *t;
    int flag, update_num, i;

    group_pool[new_ngb_id].used = USED_FOR_MAIN_GROUP;
    clr_nbr_pool[group_pool[new_ngb_id].element->color] = 0;

    // remove new group from my neighbors
    my_ngb = &pGroup->neighbors;
    while(my_ngb->next)
    {
        if(my_ngb->next->id == new_ngb_id)
        {
            my_ngb->next = my_ngb->next->next;
            break;
        }
        my_ngb = my_ngb->next;
    }

    // add neighbors of new group ot my neighbours
    new_ngb = group_list[new_ngb_id].neighbors.next;
    update_num = 0;
    while(new_ngb)
    {
        if((0 != group_list[new_ngb->id].used) || (new_ngb->id == my_gr_id)) {
            new_ngb = new_ngb->next;
            continue;
        }

        flag = 1;
        if(clr_nbr_pool[group_pool[new_ngb->id].element->color] != 0) {
            brings_together(clr_nbr_pool[group_pool[new_ngb->id].element->color], new_ngb->id);
            clr_stat[group_pool[new_ngb->id].element->color] -= group_pool[new_ngb->id].group_num;
            ngb_for_update[update_num++] = clr_nbr_pool[group_pool[new_ngb->id].element->color];
            flag = 0;
        }

        if (flag)
        {
            my_ngb = &pGroup->neighbors;
            while(my_ngb->next)
            {
                if(my_ngb->next->id > new_ngb->id)
                    break;
                my_ngb = my_ngb->next;
            }

            t = new_ngb;
            new_ngb = new_ngb->next;
            t->next = my_ngb->next;
            my_ngb->next = t;
            my_ngb = t;

            clr_nbr_pool[group_pool[my_ngb->id].element->color] = my_ngb->id;
            clr_stat[group_pool[my_ngb->id].element->color] -= group_pool[my_ngb->id].group_num;

            group_pool[my_ngb->id].used |= USED_FOR_NEIGHBOR;

            ngb_for_update[update_num++] = my_ngb->id;
            continue;
        }

        new_ngb = new_ngb->next;
    }

    for(i = 0; i < update_num; i++) {
        update_my_neighbors(ngb_for_update[i]);
    }
}

inline void get_new_group(group_t *pGroup)
{
    neighbor_t *my_nbr;
    neighbor_t *my_nbr_c;
    neighbor_t *my_nbr_nbr;

    // decrease my neighbours, neighbours num
    my_nbr = pGroup->neighbors.next;
    while(my_nbr) {
        group_pool[my_nbr->id].used |= USED_FOR_NEIGHBOR; //todo move
        my_nbr = my_nbr->next;
    }

    // remove start group color
    clr_stat[pGroup->element->color] -= pGroup->group_num;
    
    // combine neighbors whit same colors
    my_nbr = pGroup->neighbors.next;
    while(my_nbr)
    {
        my_nbr_c = my_nbr;
        while(my_nbr_c->next)
        {
            if (group_pool[my_nbr->id].element->color == group_pool[my_nbr_c->next->id].element->color)
            {
                brings_together(my_nbr->id, my_nbr_c->next->id);
                my_nbr_c->next = my_nbr_c->next->next;
                if (!my_nbr_c->next) break;
            } else {
                my_nbr_c = my_nbr_c->next;
            }
        }
        my_nbr = my_nbr->next;
    }

    // put in color/neighbor lockup table
    my_nbr = pGroup->neighbors.next;
    while(my_nbr)
    {
        clr_stat[group_pool[my_nbr->id].element->color] -= group_pool[my_nbr->id].group_num;
        clr_nbr_pool[group_pool[my_nbr->id].element->color] = my_nbr->id;
        my_nbr = my_nbr->next;
    }

    my_nbr = pGroup->neighbors.next;
    while(my_nbr)
    {
        group_pool[my_nbr->id].common_clr_with_base = 0;
        group_pool[my_nbr->id].ngb_num = 0;
        my_nbr_nbr = group_pool[my_nbr->id].neighbors.next;
        while (my_nbr_nbr)
        {
            if(0 == group_pool[my_nbr_nbr->id].used)
            {
                if(clr_nbr_pool[group_pool[my_nbr_nbr->id].element->color]) {
                    group_pool[my_nbr->id].common_clr_with_base++;
                }
                group_pool[my_nbr->id].ngb_num++;
            }
            my_nbr_nbr = my_nbr_nbr->next;
        }

        my_nbr = my_nbr->next;
    }
}

inline int get_next_color(neighbor_t *nbr)
{
    neighbor_t *itr;

    itr = nbr->next;
    while(itr)
    {
        if (0 == clr_stat[group_pool[itr->id].element->color]) {
            nbr = itr;
            break;
        }

        if(group_list[itr->id].ngb_num >= group_list[nbr->id].ngb_num) {
            if(group_list[itr->id].ngb_num == group_list[nbr->id].ngb_num) {
                if (group_list[itr->id].common_clr_with_base >= group_list[nbr->id].common_clr_with_base) {
                    if (group_list[itr->id].common_clr_with_base == group_list[nbr->id].common_clr_with_base) {
                        if (group_list[itr->id].group_num <= group_list[nbr->id].group_num) {
                            if (group_list[itr->id].group_num == group_list[nbr->id].group_num) {
                                if (clr_stat[group_list[itr->id].element->color] < clr_stat[group_list[nbr->id].element->color]) {
                                    nbr = itr;
                                }
                            } else 
                            {
                                nbr = itr;
                            }
                        }
                    } else {
                        nbr = itr;
                    }
                }
            } else {
                nbr = itr;
            }
        }
        itr = itr->next;
    }

    return (nbr->id);
}

inline int process(element_t* b, int N, int C)
{
    group_t *grp;
    group_t *grp_best;
    group_t *my_group;
    int i, new_color_id;

#ifndef TEST
    i = 0;
    while(trys_ids[i])
    {
        group_pool[trys_ids[i]].good_for_start_elememt = 0;
        i++;
    }
#else
    i = 1;
#endif

    // choose start elelment
    if (i) {
        grp = group_pool->next;
        grp_best = NULL;
        while(grp) {
            if(0 != (grp->good_for_start_elememt & test_group)) {
                if(grp_best == NULL) {
                    grp_best = grp;
                    continue;
                }

                if(grp->ngb_num > grp_best->ngb_num) {
                    grp_best = grp;
                } else if(grp->ngb_num == grp_best->ngb_num) {
                    if(grp->group_num < grp_best->group_num) {
                        grp_best = grp;
                    } else if (grp->group_num == grp_best->group_num) {
                        if(clr_stat[grp->element->color] < clr_stat[grp_best->element->color]) {
                            grp_best = grp;
                        }
                    }
                }
            }
            grp = grp->next;
        }

        if (NULL == grp_best)
        {
            if(test_group & 0x80000000) {
                return 1;
            } else {
                test_group <<= 1;
                test_group  |= 1;
                return 0;
            }
        }
    } else {
        grp_best = &group_pool[b[(N / 2) * (N + 1)].gr_id];
    }

    my_gr_id = grp_best - group_pool;
    
//print("Start group ID : %d\n", my_gr_id); 
    my_group = grp_best;
    my_group->used = USED_FOR_MAIN_GROUP;
    get_new_group(my_group);

    i = 0;
    while(trys_ids[i]) i++;
    trys_ids[i] = my_gr_id; 

    i = 0;
    result[result_id][i++] = 0;// ready
    result[result_id][i++] = 0;// count
    result[result_id][i++] = (grp_best->element - b) / N;// y
    result[result_id][i++] = (grp_best->element - b) % N;// x

    // process
    while(my_group->neighbors.next)
    {
#ifndef TEST
        if((stf_time() - start_time) > MAX_TIME) return 1;
#endif

        // choose new color
        new_color_id = get_next_color(my_group->neighbors.next);

        //apply new color
        apply_new_color(my_group, new_color_id);

        result[result_id][i++] = group_list[new_color_id].element->color;
        trys++;
    }

    result[result_id][0] = 1;// ready
    result[result_id][1] = trys;// count

    if(0 == result[(~result_id) & 1][0]) {
        result_id = (~result_id) & 1;
    } else if (result[(~result_id) & 1][1] > result[result_id][1]) {
        result_id = (~result_id) & 1;
    }

    return 0;
}

int _tmain(int argc, _TCHAR* argv[])
{
    start_time = stf_time();

    element_t *board;

    FILE *f_in;
    FILE *f_out;
    int x, y, i;
    int *p;

    fopen_s(&f_in, "flood-it.in", "r");
    fscanf_s(f_in, "%d%d", &N, &C);

    board = stf_calloc(element_t, (N * N));

    element_t *ptr = board;
    for (y = 0; y < N; y++) {
        for (x = 0; x < N; x++)
            fscanf_s(f_in, "%d", &((ptr++)->color));
    } fclose(f_in);

    result_id = 0;
    result[0][0] = 0;//ready
    result[1][0] = 0;
    result[0][1] = 0;// count
    result[1][1] = 0;
    result[0][2] = 0;// y
    result[1][2] = 0;
    result[0][3] = 0;// x
    result[1][3] = 0;

    init(board, N);

    print("Init duration : %d\n", stf_time() - start_time); 

#ifndef TEST 
    while ((stf_time() - start_time) < MAX_TIME) {

        trys = 0;

        if(1 == process(board, N, C)) break;

        print("Process duration : %d, trys: %d \n", (stf_time() - start_time), trys);

        init_sec(board, N);
    }
#else
    process(board, N, C);
    print("Process duration : %d, trys: %d\n", (stf_time() - start_time), trys);
#endif

    // output result
    if ((result[0][0]) && (result[1][0])) {
        if (result[0][1] < result[1][1]) {
            p = &result[0][1];
        } else {
            p = &result[1][1];
        }
    } else if (result[0][0]) {
        p = &result[0][1];
    } else {
        p = &result[1][1];
    }

    fopen_s(&f_out, "flood-it.out", "w");
    fprintf_s(f_out, "%d\n", p[0]);
    fprintf_s(f_out, "%d %d\n", p[1], p[2]);
    for (i = 3; i < (p[0] + 3); i++) {
        fprintf_s(f_out, "%d\n", p[i]);
    }
    fclose(f_out);

    pause();
	return 0;
}