#include "stdafx.h"

#include "stuffs.h"

clock_t stf_get_timer()
{return (clock() * CLOCKS_PER_SEC) / 1000;}

stf_time_limit_t *stf_time_limit_start(int time_limit_ms)
{
    stf_time_limit_t *tl;
    clock_t start = stf_get_timer();
    tl = stf_malloc(stf_time_limit_t, 1);
    tl->start_time = start;
    tl->time_limit_ms = time_limit_ms;
    return tl;
}

bool stf_chek_time_limit(stf_time_limit_t *tl)
{
    return ((stf_get_timer() - tl->start_time) > tl->time_limit_ms);
}

int stf_available_time(stf_time_limit_t *tl)
{
    return (tl->time_limit_ms - (stf_get_timer() - tl->start_time));
}

void stf_time_limit(stf_time_limit_t *tl)
{
    stf_free(tl);
}

void stf_print_duration(stf_time_limit_t *tl)
{
    int duration = (stf_get_timer() - tl->start_time);

    int sec = duration / 1000;
    int ms = duration - (sec * 1000);

    printf("Duration : %d sec and %d ms\n", sec, ms);
}

int stf_time_duration(stf_time_limit_t *tl)
{
    int duration = (stf_get_timer() - tl->start_time);

   return duration;
}
stf_stack_t *stf_create_stack(int size)
{
    stf_stack_t *result = stf_malloc(stf_stack_t, 1);
    result->stack_storage = stf_malloc(int, size);
    result->stack_head = result->stack_storage;
    result->usage = 0;
    result->capacity = size;
    return result;
}

bool stf_check_stack(stf_stack_t *stack)
{
    return ((stack->stack_head >= stack->stack_storage) && (stack->stack_head < stack->stack_storage + stack->capacity))?(true):(false);
}
