#ifndef __STUFFS_H___
#define __STUFFS_H___

//#define VERBAL_MODE
//#define TEST
#define MAX_TIME 950

#include "stdafx.h"
#include <stdlib.h>
#include "malloc.h"
#include "time.h"

#ifndef VERBAL_MODE
#define pause()
#define print(txt, ...)
#define ASSERT(msg, code) 
#define ASSERT_IF(a, msg, code) 

#else //VERBAL_MODE
#define pause() getchar();
#define print(txt, ...) printf(txt, __VA_ARGS__)
#define ASSERT(msg, code) {print( "\nProgram ASSERT !\n\nMessage : " msg "\n\nFile : "__FILE__"\nLine : %d\n", __LINE__ ); EXIT(code);}
#define ASSERT_IF(a, msg, code) if (a) {ASSERT(msg, code);}

#endif //VERBAL_MODE

#define EXIT(code)    {pause(); exit(code);}

/* Memory Stuffs */
#define stf_malloc(type, count) ((type*)(malloc(sizeof(type)*(count))))
#define stf_calloc(type, count) ((type*)(calloc((count), sizeof(type))))
#define stf_free(ptr) free(ptr)
#define stf_min(a, b) ((a<b)?a:b)
#define stf_max(a, b) ((a<b)?b:a)
#define stf_swap(a, b, type) {type ___stf_swap_tmp_ = (a); (a) = (b); (b) = ___stf_swap_tmp_;}
#define stf_time() ((int)((clock() * CLOCKS_PER_SEC) / 1000))

#define stf_push(stack, el) *((stack)->stack_head) = (el); (stack)->stack_head++; (stack)->usage++;
#define stf_pop(stack) ((stack)->stack_head--, (stack)->usage--, *((stack)->stack_head))
#define stf_stack_empty(stack) ((stack)->stack_head == (stack)->stack_storage)
/* Timer Stuffs */
typedef struct stf_time_limit_struct stf_time_limit_t;
struct stf_time_limit_struct{
    clock_t start_time;
    int        time_limit_ms;
};

typedef struct stf_stack_struct stf_stack_t;
struct stf_stack_struct{
    int *stack_storage;
    int *stack_head;
    int usage;
    int capacity;
};

/* */
#define stf_swap_ints(a, b) {a^=b^=a;b^=a;}
/* Prototypes */
clock_t stf_get_timer();
stf_time_limit_t *stf_time_limit_start(int time_limit_ms);
bool stf_chek_time_limit(stf_time_limit_t *tl);
void stf_time_limit(stf_time_limit_t *tl);
int stf_available_time(stf_time_limit_t *tl);
void stf_print_duration(stf_time_limit_t *tl);


stf_stack_t *stf_create_stack(int size);
bool stf_check_stack(stf_stack_t *stack);
int stf_time_duration(stf_time_limit_t *tl);

#endif //__STUFFS_H___
